# ./addons/eventscripts/popuptest/popuptest.py

import cheappopup
import es
import gamethread
import random

reload(cheappopup)

popup = cheappopup.popup

def player_say(event_var):
   userid = event_var['userid']
   text   = event_var['text']
   if text == '!ptest1':
      test1(userid)
   elif text == '!ptest2':
      test2(userid)
   elif text == '!ptest3':
      test3(userid)


def test1(userid):
   es.msg('test 1 name %s' % es.getplayername(userid))
   popup.send(userid, 0, 'Make a menu selection (0 - 9)', callback=test1_callback)

def test1_callback(userid, item, name):
   es.msg(es.getplayername(userid) + "You pressed %s\n \nNow press 2 if your knife is selected\nor 3 otherwise.\n \nThe selection should be accepted\nas though the menu isn't visible" % item)
   popup.send(userid, 0, "You pressed %s\n \nNow press 2 if your knife is selected\nor 3 otherwise.\n \nThe selection should be accepted\nas though the menu isn't visible" % item, callback=test1_callback2)
   return False

def test1_callback2(userid, item, name):
   return True


def test2(userid):
   duration = random.randint(4, 8)
   es.msg('test 2 duration %s name %s' % (duration, es.getplayername(userid)))
   popup.send(userid, 0, 'This menu will be unsent in %s seconds' % duration, 'ptest', test2_unsend)
   gamethread.delayed(duration, 'popuptest', test2_unsend, (userid, 0, 'ptest'))

def test2_unsend(userid, item, name):
   es.msg('test 2 unsend item %s name %s' % (item, es.getplayername(userid)))
   popup.unsend(userid, name)
   gamethread.cancelDelayed('popuptest')


def test3(userid):
   global test3_item
   selections = ["Don't select"] * 12
   test3_item = random.randint(0, 11)
   selections[test3_item] = 'Select me!'
   es.msg('test 3 selection %s' % test3_item)
   popup.sendSelectionList(userid, 0, selections, 'Selection test', 'Back', 'Next', 'Exit', section_divider='-' * 15,
    last_next='Next popup', callback=test3_callback, no_highlight=(test3_item,))

def test3_callback(userid, item, name):
   es.msg('You chose %s, you should have chosen %s' % (item, test3_item))
   selections = ['Selection %s' % (x + 1) for x in xrange(4)]
   popup.sendSelectionList(userid, 0, selections, 'Try to chose an invalid selection', 'back', 'next', 'exit', section_divider=' ',
    first_back='Previous popup', callback=test3_callback2)
   return False

def test3_callback2(userid, item, name):
   if item == -1:
      test3(userid)
   elif item is None:
      es.tell(userid, 'You selected Exit')
   else:
      es.tell(userid, 'You selected %s' % (item + 1))
   return False